function lambda = cssvm_lambdamax(x, y, hkernel, kernelparam, gamma)

N = length(y);
Nm = sum(y==-1);
if nargin<5
    gamma = Nm/N;       % balanced cs-svm
end

K = hkernel(x, x, kernelparam);
K = (K+K')/2;
Kt = diag(y)*K*diag(y);

alpha = repmat(y==-1,1,length(gamma))+y*gamma';
% alpha = gamma*(y==1) + (1-gamma)*(y==-1);
gk = Kt*alpha;
lambda = max(gk(:));
